# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin

try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
try:
    from urlparse import urlparse, parse_qs
except ImportError:
    from urllib.parse import urlparse, parse_qs
import sys

if sys.version_info < (2, 7) or (sys.version_info >= (3, 0) and sys.version_info < (3, 1)):
    import simplejson as json
    from simplejson import OrderedDict
else:
    import json
    from collections import OrderedDict
import localau


def httpget(url):
    try:
        return urlopen(url).read().decode('utf-8')
    except:
        return False


def item(title, para, isFolder=True):
    listitem = xbmcgui.ListItem(title)
    if 'title' not in para:
        para['title'] = title
    for k in para:
        if isinstance(para[k], unicode):
            para[k] = para[k].encode('utf-8')
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(para), listitem, isFolder)


def play(title, url, header={}):
    listitem = xbmcgui.ListItem(title)
    h = []
    if header:
        url += '|' + urlencode(header)
    xbmc.Player().play(url, listitem)


def sub1(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if o.path[-5:] == '.m3u8':
        return False
    if o.netloc == 'www.localmv.com':
        if l > 1 and p[1] == 'play':
            return False
    if o.netloc == 'sports.localau.com':
        if l > 1 and p[1] == 'play':
            return False
    return True


def sub2(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if o.path[-5:] == '.m3u8':
        play('', url)
        return
    if o.netloc == 'sports.localau.com':
        if l < 2:
            ret = localau.sports(url)
        elif p[1] == 'game':
            ret = localau.game(url)
        elif p[1] == 'play':
            ret = localau.sport(url)
        else:
            xbmcgui.Dialog().ok('错误', '错误代码: localau 021')
            return
    elif o.netloc == 'www.localmv.com':
        if l < 2:
            xbmcgui.Dialog().ok('错误', '错误代码: localau 022')
            return
        if p[1] == 'video':
            ret = localau.video(url)
        elif p[1] in ['dianying', 'dianshiju', 'zongyi', 'dongman', 'document']:
            if 'page' in q:
                page = int(q['page'][0])
            else:
                page = 1
            ret = localau.category(url, p[1], page)
        elif p[1] == 'play':
            ret = localau.play(url)
        else:
            xbmcgui.Dialog().ok('错误', '错误代码: localau 023')
            return
    else:
        xbmcgui.Dialog().ok('错误', '错误代码: localau 020')
        return
    if 'code' in ret:
        xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
        return
    if 'item' in ret:
        for elem in ret['item']:
            item(elem['title'], elem, sub1(elem['url']))
        xbmcplugin.endOfDirectory(handle)
    if 'url' in ret:
        if 'header' in ret:
            play('', ret['url']['m3u8'], ret['header'])
        else:
            play('', ret['url']['m3u8'])


def sub3(content):
    try:
        data = json.loads(content, object_pairs_hook=OrderedDict)
    except:
        xbmcgui.Dialog().ok('错误', '错误代码: localau 030')
        return
    for k in data:
        if isinstance(data[k], dict):
            item(k, {'json': json.dumps(data[k])})
        else:
            url = data[k]
            item(k, {'url': url}, sub1(url))
    xbmcplugin.endOfDirectory(handle)


def get_node(url):
    content = httpget(url)
    if not content:
        xbmcgui.Dialog().ok('错误', '错误代码: localau 010')
        return
    sub3(content)


handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
    get_node('http://ims.tian-le.com/localau.json')
else:
    o = urlparse(url)
    q = parse_qs(o.query)
    if 'json' in q:
        sub3(q['json'][0])
    if 'url' in q:
        sub2(q['url'][0])
